// Source code from the MSDN Library (AniEdit, ANIFILE.C, 21-Apr-1993 JonPa)

typedef struct _FRAME3			// R}
{
	int 		iFrame; 		// \鏇ԁisv̏ꍇj
	JIF 		jif;			// \ԁi1 jif = 1 / 60 bjisv̏ꍇj
} FRAME3, *PFRAME3;

typedef struct _ANICUR2
{
	ANIHEADER	anih;
	CHAR		azTitle[CCH_TITLE]; 	// ANI t@C̑薼
	CHAR		azCreator[CCH_CREATOR]; // ANI t@C̍Җ
	CHAR		azFilename[MAX_PATH];	// ANI t@C̃tpX
	CHAR		azSavepath[MAX_PATH];	// ICO t@C̕ۑtH_[̃pX
} ANICUR2;

ANICUR2	ganiAcon2;

BOOL ReadTag(HANDLE hf, PRTAG ptag)
{
	DWORD cbActual;
	
	ptag->ckID = ptag->ckSize = 0L;
	if(!ReadFile(hf, ptag, sizeof(RTAG), &cbActual, NULL) ||
			(cbActual != sizeof(RTAG)))
		return FALSE;
	return TRUE;
}// ReadTag

BOOL ReadTagID(HANDLE hf, FOURCC *pckID)
{
	DWORD cbActual;
	
	*pckID = 0L;
	if(!ReadFile(hf, pckID, sizeof(FOURCC), &cbActual, NULL) ||
			(cbActual < sizeof(FOURCC)))
		return FALSE;
	return TRUE;
}// ReadTagID

BOOL ReadChunk(HANDLE hf, PRTAG ptag, PVOID pv)
{
	DWORD cbActual;
	
	if(!ReadFile(hf, pv, ptag->ckSize, &cbActual, NULL) ||
			(cbActual != ptag->ckSize))
		return FALSE;
	// 2 oCgẼt@C|C^[
	if(ptag->ckSize & 1)
		SetFilePointer(hf, 1, NULL, FILE_CURRENT);
	return TRUE;
}// ReadChunk

BOOL ReadChunkN(HANDLE hf, PRTAG ptag, PVOID pv, DWORD cbMax)
{
	DWORD cbActual;
	DWORD cbRead = min(cbMax, ptag->ckSize);

	if(!ReadFile(hf, pv, ptag->ckSize, &cbActual, NULL) ||
			(cbActual != cbRead))
		return FALSE;
	// 2 oCgẼt@C|C^[
	cbRead = ptag->ckSize - cbActual;
	if(ptag->ckSize & 1)
		cbRead++;
	return SetFilePointer(hf, cbRead, NULL, FILE_CURRENT) != 0xFFFFFFFF;
}// ReadChunkN

BOOL SkipChunk(HANDLE hf, PRTAG ptag)
{
	// Round ptag->ckSize up to nearest word boundary to maintain alignment
	return SetFilePointer(hf, PADUP(ptag->ckSize), NULL, FILE_CURRENT) !=
			0xFFFFFFFFL;
}// SkipChunk

void ReadIconFromFile(HANDLE hf, DWORD ckSize, int iFrame){
	LPBYTE	pBuf = (LPBYTE) malloc(ckSize);
	DWORD	cbRead;
	
	if(pBuf){
		if(ReadFile(hf, pBuf, ckSize, &cbRead, NULL) && cbRead == ckSize){
			WORD wType; // 1:icon, ̑:cursor
			memcpy(&wType, (BYTE*)pBuf+sizeof(WORD), sizeof(WORD));
			// ico, cur t@C̕ۑ
			char filename[MAX_PATH];
			char title[MAX_PATH];
			GetFileTitle(ganiAcon2.azFilename, title, sizeof(title));
			char *p = strrchr(title, '.');
			if(p){
				strcpy(p, "");
			}
			_snprintf(filename, sizeof(filename)-5, "%s\\%s%02d", ganiAcon2.azSavepath, title, iFrame+1);
			if(wType == 1){
				strcat(filename, ".ico");
			}
			else{
				strcat(filename, ".cur");
			}
			FILE	*file;
			if(file = fopen(filename, "wb")){
				fwrite(pBuf, sizeof(BYTE), ckSize, file);
				fclose(file);
			}
		}
	}
	if(pBuf != NULL)
		free(pBuf);
}// ReadIconFromFile

BOOL ReadAniFile()
{
	HANDLE	hf;
	RTAG tag;
	BOOL fSuccess = FALSE;
	JIF *pjifRate = NULL;
	DWORD *pseq = NULL;
	DWORD i,iFrame = 0;
	PFRAME3	pfrmFram3 = NULL;
	
	hf = CreateFile(ganiAcon2.azFilename, GENERIC_READ, FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hf == INVALID_HANDLE_VALUE)
		goto laiFileErr;
	if(!ReadTag(hf, &tag))
		goto laiFileErr;
	if(tag.ckID != FOURCC_RIFF)
		goto laiFileErr;
	if(!ReadTagID(hf, &tag.ckID))
		goto laiFileErr;
	if(tag.ckID != FOURCC_ACON)
		goto laiFileErr;
	
	// look for 'anih', 'rate', 'seq ', and 'icon' chunks
	while(ReadTag(hf, &tag)){
		switch(tag.ckID)
		{
		case FOURCC_anih:
			// ANIHEADER \̂̓ǂݍ
			if(!ReadChunk(hf, &tag, &ganiAcon2.anih))
				goto laiFileErr;
			if(!(ganiAcon2.anih.fl & AF_ICON) || (ganiAcon2.anih.cFrames == 0))
				goto laiFileErr;
			// pfrmFram3 ̃m
			pfrmFram3 = (PFRAME3) malloc(ganiAcon2.anih.cSteps * sizeof(FRAME3));
			// pjifRate  pseq ̃m
			pjifRate = (PJIF) malloc(ganiAcon2.anih.cSteps * 
									(sizeof(JIF) + sizeof(DWORD)));
			if(pjifRate == NULL)
				goto laiFileErr;
			pseq = (DWORD *)(pjifRate + ganiAcon2.anih.cSteps);
			// z̏
			for(i=0;i<(int)ganiAcon2.anih.cSteps;i++){
				pfrmFram3[i].jif = pjifRate[i] = ganiAcon2.anih.jifRate;
				pfrmFram3[i].iFrame = pseq[i] = i;
			}
			break;
		case FOURCC_rate:
			// R}Ƃ̕\Ԃ̓ǂݍ
			if(!ReadChunk(hf, &tag, (PBYTE)pjifRate))
				goto laiFileErr;
			for(i=0;i<ganiAcon2.anih.cSteps;i++){
				pfrmFram3[i].jif = pjifRate[i];
			}
			break;
		case FOURCC_seq:
			// R}̏Ԃ̓ǂݍ
			if(!ReadChunk(hf, &tag, (PBYTE)pseq))
				goto laiFileErr;
			for(i=0;i<ganiAcon2.anih.cSteps;i++){
				pfrmFram3[i].iFrame = pseq[i];
			}
			break;
		case FOURCC_LIST:{
			DWORD cbChunk = PADUP(tag.ckSize);
			// `ÑXg fram ̏ꍇ
			if(!ReadTagID(hf, &tag.ckID))
				goto laiFileErr;
			cbChunk -= sizeof(tag.ckID);
			if(tag.ckID == FOURCC_fram){
				while(cbChunk >= sizeof(tag)){
					if(!ReadTag(hf, &tag))
						goto laiFileErr;
					cbChunk -= sizeof(tag);
					if(tag.ckID == FOURCC_icon){
						// J[\摜̓ǂݍ
						ReadIconFromFile(hf, tag.ckSize, iFrame);
						iFrame ++;
					}
					else{
						// Kv̂Ȃ`N͓ǂݔ΂
						SkipChunk(hf, &tag);
					}
					cbChunk -= PADUP(tag.ckSize);
				}
			}
			else if(tag.ckID == FOURCC_INFO){
				// INAM `N IART `NT
				while(cbChunk >= sizeof(tag)){
					if(!ReadTag(hf, &tag))
						goto laiFileErr;
					cbChunk -= sizeof(tag);
					switch(tag.ckID)
					{
					case FOURCC_INAM:
						if(cbChunk < tag.ckSize ||
								!ReadChunkN(hf, &tag, ganiAcon2.azTitle,
								sizeof(ganiAcon2.azTitle)))
							goto laiFileErr;
						cbChunk -= PADUP(tag.ckSize);
						break;
					case FOURCC_IART:
						if(cbChunk < tag.ckSize ||
								!ReadChunkN(hf, &tag, ganiAcon2.azCreator,
								sizeof(ganiAcon2.azCreator)))
							goto laiFileErr;
						cbChunk -= PADUP(tag.ckSize);
						break;
					default:
						if(!SkipChunk(hf, &tag))
							goto laiFileErr;
						cbChunk -= PADUP(tag.ckSize);
						break;
					}
				}
			}
			else{
				// fram Xgł INFO XgłȂ`N͓ǂݔ΂
				tag.ckSize = cbChunk;
				SkipChunk(hf, &tag);
				break;
			}
			break;
		}
		default:
			// ̃`N͊֌WȂǂݔ΂
			if(!SkipChunk(hf, &tag))
				goto laiFileErr;
			break;
		}
	}
	// t[̑ݒ肷
	ganiAcon2.anih.cFrames = iFrame;
	fSuccess = TRUE;
laiFileErr:
	if(pjifRate != NULL)
		free(pjifRate);
	if(pfrmFram3 != NULL)
		free(pfrmFram3);
	CloseHandle(hf);
	return fSuccess;
}// ReadAniFile
