// Source code from the MSDN Library (AniEdit, ANIFILE.C, 21-Apr-1993 JonPa)
#include "anicur.h"

#define CCH_TITLE					80
#define CCH_CREATOR 				80
#define PADUP(cb)					(((cb) + 1) & ~1)

typedef struct _ANICUR
{
	ANIHEADER	anih;
	CHAR		azTitle[CCH_TITLE]; 	// ANI t@C̑薼
	CHAR		azCreator[CCH_CREATOR]; // ANI t@C̍Җ
} ANICUR;

typedef struct _FRAME2		// R}
{
	CHAR	azCurFile[MAX_PATH]; 	// ǂݍރt@Ci*.cur or *.icoj
	JIF		jifRate;				// ACRƂ̕\
} FRAME2, *PFRAME2;

ANICUR	ganiAcon;
PFRAME2	gpFram2 = NULL;
UINT	gnumFram2 = 0;			// gpFram2 ̗vf

BOOL WriteTag(HANDLE hf, PRTAG prtag)
{
	DWORD cbWritten;

	return (WriteFile(hf, prtag, sizeof(RTAG), &cbWritten, NULL) &&
			cbWritten == sizeof(RTAG));
}// WriteTag

BOOL WriteType(HANDLE hf, FOURCC ckID)
{
	DWORD cbWritten;

	return (WriteFile(hf, &ckID, sizeof(FOURCC), &cbWritten, NULL) &&
			cbWritten == sizeof(FOURCC));
}// WriteType

BOOL WriteTagData(HANDLE hf, PRTAG prtag, VOID *pvData)
{
	DWORD cbWritten;
	DWORD cbWrite = PADUP(prtag->ckSize);

	return	WriteTag(hf, prtag) && WriteFile(hf, pvData, cbWrite,
			&cbWritten, NULL) && cbWritten == cbWrite;
}// WriteTagData

BOOL SaveFile(char *anifilename)
{
	HANDLE	hf1;
	RTAG	rtag;
	JIF		jifRate;
	BOOL	fSuccess = FALSE;
	DWORD	cbFile, cbFram, cbINFO, cbTitle, cbAuthor;
	DWORD	i,cFrames;
	BOOL	fRate, fSeq;
	
	if(!gpFram2)
		return fSuccess;
	cFrames = gnumFram2;
	hf1 = CreateFile(anifilename, GENERIC_WRITE, 0, NULL,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hf1 == INVALID_HANDLE_VALUE)
		goto laiFileErr;
	fSeq = FALSE;
	fRate = FALSE;
	jifRate = gpFram2[0].jifRate;
	for(i=1;i<cFrames;i++){
		if(gpFram2[i].jifRate != jifRate){
			fRate = TRUE;
			break;
		}
	}
	cbINFO = cbFram = cbFile = cbTitle = cbAuthor = 0;
	cbTitle  = strlen(ganiAcon.azTitle);
	cbAuthor = strlen(ganiAcon.azCreator);
	for(i=0;i<cFrames;i++){
		HANDLE	hf2;
		hf2 = CreateFile(gpFram2[i].azCurFile, GENERIC_READ, FILE_SHARE_READ,
							NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hf2 != INVALID_HANDLE_VALUE){
			DWORD cbSize = GetFileSize(hf2, NULL);
			if(cbSize > 0 && cbSize != 0xFFFFFFFF){
				cbFram += sizeof(RTAG);
				cbFram += PADUP(cbSize);
			}
		}
		CloseHandle(hf2);
	}
	cbFram += sizeof(FOURCC);	//fram type
	cbFile = cbFram;
	cbFile += sizeof(FOURCC)	//ACON type
			+ sizeof(RTAG)		//anih tag
			+ PADUP(sizeof(ANIHEADER))
			+ sizeof(RTAG); 	//LIST tag (for fram list)
	if(cbTitle || cbAuthor){
		// Remember, azCreator, and azTitle are ANSI strings!
		if(cbTitle){
			cbTitle += 1;	//add in ASCIIZ terminator
			cbINFO +=	sizeof(RTAG) +	//INAM tag
						PADUP( cbTitle * sizeof(char));
		}
		if(cbAuthor){
			cbAuthor += 1; //add in ASCIIZ terminator
			cbINFO +=	sizeof(RTAG) +	//IART tag
						PADUP(cbAuthor * sizeof(char));
		}
		cbINFO +=	sizeof(FOURCC); 	//INFO type
		cbFile +=	sizeof(RTAG) +		//LIST tag
					cbINFO;
	}
	if(fSeq){
		cbFile += sizeof(RTAG) +		//seq tag
					PADUP(cFrames * sizeof(DWORD));
	}
	if(fRate){
		cbFile += sizeof(RTAG) +		//rate tag
					PADUP(cFrames * sizeof(JIF));
	}
	rtag.ckID = FOURCC_RIFF;
	rtag.ckSize = cbFile;
	if(!WriteTag(hf1, &rtag))
		goto laiFileErr;
	if(!WriteType(hf1, FOURCC_ACON))
		goto laiFileErr;
	if(cbTitle || cbAuthor){
		rtag.ckID = FOURCC_LIST;
		rtag.ckSize = cbINFO;
		if(!WriteTag(hf1, &rtag))
			goto laiFileErr;
		if(!WriteType(hf1, FOURCC_INFO))
			goto laiFileErr;
		if(cbTitle){
			rtag.ckID = FOURCC_INAM;
			rtag.ckSize = cbTitle;
			if(!WriteTagData(hf1, &rtag, ganiAcon.azTitle))
				goto laiFileErr;
		}
		if(cbAuthor){
			rtag.ckID = FOURCC_IART;
			rtag.ckSize = cbAuthor;
			if(!WriteTagData(hf1, &rtag, ganiAcon.azCreator))
				goto laiFileErr;
		}
	}
	ganiAcon.anih.cbSizeof = sizeof(ganiAcon.anih);
	ganiAcon.anih.cFrames = cFrames;
	ganiAcon.anih.cSteps = cFrames;
	ganiAcon.anih.cx = 0;
	ganiAcon.anih.cy = 0;
	ganiAcon.anih.cBitCount = 0;
	ganiAcon.anih.cPlanes = 0;
	if(fRate)
		ganiAcon.anih.jifRate = 0;
	else
		ganiAcon.anih.jifRate = jifRate;
	ganiAcon.anih.fl = AF_ICON | (fSeq ? AF_SEQUENCE : 0);
	rtag.ckID = FOURCC_anih;
	rtag.ckSize = sizeof(ganiAcon.anih);
	if(!WriteTagData(hf1, &rtag, &(ganiAcon.anih)))
		goto laiFileErr;
	if(fRate){
		rtag.ckID = FOURCC_rate;
		rtag.ckSize = cFrames * sizeof(JIF);
		PJIF pjif = (PJIF) malloc(rtag.ckSize);
		for(i=0;i<cFrames;i++){
			pjif[i] = gpFram2[i].jifRate;
		}
		WriteTagData(hf1, &rtag, pjif);
		if(pjif)
			free(pjif);
	}
	if(fSeq){
		rtag.ckID = FOURCC_seq;
		rtag.ckSize = cFrames * sizeof(DWORD);
		LPDWORD pseq = (LPDWORD) malloc(rtag.ckSize);
		for(i=0;i<cFrames;i++){
			pseq[i] = 0;
		}
		WriteTagData(hf1, &rtag, pseq);
		if(pseq)
			free(pseq);
	}
	rtag.ckID = FOURCC_LIST;
	rtag.ckSize = cbFram;
	if(!WriteTag(hf1, &rtag))
		goto laiFileErr;
	if(!WriteType(hf1, FOURCC_fram))
		goto laiFileErr;
	for(i=0;i<cFrames;i++){
		HANDLE	hf2;
		hf2 = CreateFile(gpFram2[i].azCurFile, GENERIC_READ, FILE_SHARE_READ,
							NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hf2 != INVALID_HANDLE_VALUE){
			DWORD cbIcon = GetFileSize(hf2, NULL);
			if(cbIcon > 0 && cbIcon != 0xFFFFFFFF){
				LPBYTE	pBuf = (LPBYTE) malloc(cbIcon);
				DWORD	cbRead;
				if(ReadFile(hf2, pBuf, cbIcon, &cbRead, NULL) && cbRead == cbIcon){
					rtag.ckID = FOURCC_icon;
					rtag.ckSize = cbIcon;
					WriteTagData(hf1, &rtag, pBuf);
				}
				if(pBuf)
					free(pBuf);
			}
		}
		CloseHandle(hf2);
	}
	fSuccess = TRUE;
laiFileErr:
	CloseHandle(hf1);
	return fSuccess;
}// SaveFile
