#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "IconToAni.h"
#include "AniToIcon.h"
#include "SelectFolder.h"
#include "resource.h"

#pragma comment(lib,"comctl32.lib")

#define MYWNDTITLE		"anicur"
#define COL_NUM 		2		// J
#define JIF_LEN 		8		// JIF ̕
#define JIF_INIT 		"3"		// JIF ̏l

typedef struct _FRAME			// R}
{
	char	filename[MAX_PATH]; // t@Ci*.cur, *.icoj
	char	title[MAX_PATH];	// t@C^Cg
	char	jif[JIF_LEN];		// \ԁi1 jif = 1 / 60 bj
} FRAME, *PFRAME;

HWND g_hDlg = NULL;

// J̃NbNŃ\[gƂ̃\[g̃[
int CALLBACK ProcListViewCmp(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	PFRAME	pfram1 = (PFRAME)lParam1;
	PFRAME	pfram2 = (PFRAME)lParam2;
	int 	iResult = 0;
	
	if (pfram1 && pfram2)
	{
		switch(lParamSort)
		{
		case 0:
			iResult = strcmp(pfram1->filename, pfram2->filename);
			break;
		case 1:
			iResult = strcmp(pfram1->jif, pfram2->jif);
			break;
		}
	}
	return iResult;
}// ProcListViewCmp

// ACe̒ǉ
void Add_One_Item(HWND hList, HIMAGELIST hIml, FRAME fram)
{
	LVITEM		lvI;
	ZeroMemory(&lvI, sizeof(lvI));
	lvI.mask		= LVIF_TEXT | LVIF_IMAGE | LVIF_STATE | LVIF_PARAM;
	lvI.state		= 0;
	lvI.stateMask	= -1;		// SĂ̏Ԃݒ
	lvI.iItem		= ListView_GetItemCount(hList);
	lvI.iSubItem	= 0;
	lvI.iImage		= lvI.iItem;
	lvI.pszText 	= fram.title;
	PFRAME pfram = (PFRAME) new FRAME;
	*pfram = fram;
	lvI.lParam = (LPARAM) pfram;
	int index2 = ListView_InsertItem(hList, &lvI);
	if(index2 != -1){
		ListView_SetItemText(hList, index2, 1, fram.jif);
	}
	// C[WXgɃACRǉ
	HICON hIcon = ExtractIcon(GetModuleHandle(NULL), fram.filename, 0);
	ImageList_AddIcon(hIml, hIcon);
}// Add_One_Item

// LPARAM ̎擾
PFRAME Get_Lparam(HWND hList, int iItem)
{
	if(iItem != -1){
		LVITEM lvI;
		ZeroMemory(&lvI, sizeof(lvI));
		lvI.mask = LVIF_PARAM;
		lvI.iItem = iItem;
		if(ListView_GetItem(hList, &lvI)){
			PFRAME pfram = (PFRAME) (lvI.lParam);
			return pfram;
		}
	}
	return NULL;
}// Get_Lparam

// Xgr[ɃACe̒ǉiI[vt@C_CAOŊJƂj
void Add_OpenFILE(HWND hList, HIMAGELIST hIml, UINT offset, char *filename)
{
	FRAME	fram;
	
	strcpy(fram.jif, JIF_INIT);
	
	if(offset > strlen(filename)){	// ̂Ƃ
		UINT	ct,len;
		char	path[MAX_PATH];
		strncpy(path, filename, sizeof(path));
		len = offset;
		ct = 0;
		do{
			_snprintf(fram.filename, sizeof(fram.filename), "%s\\%s",path, filename+len);
			GetFileTitle(fram.filename, fram.title, sizeof(fram.title));
			Add_One_Item(hList, hIml, fram);
			ct ++;
			len += (strlen(filename+len)+1);
		}while(strlen(filename+len) > 0);
	}
	else{						// P̂Ƃ
		strncpy(fram.filename, filename, sizeof(fram.filename));
		GetFileTitle(fram.filename, fram.title, sizeof(fram.title));
		Add_One_Item(hList, hIml, fram);
	}
}// Add_OpenFILE

// I[vt@C_CAO
void Open_FileDlg(HWND hDlg, HWND hList, HIMAGELIST hIml)
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH*64] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hDlg;
	ofn.Flags = OFN_PATHMUSTEXIST | 
				OFN_FILEMUSTEXIST | 
				OFN_ALLOWMULTISELECT | 
				OFN_EXPLORER | 
				OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	//tB^w肷ƂB
	ofn.lpstrFilter =	"ACREJ[\t@C\0" "*.ico;*.cur\0" 
						"ACRt@C (*.ico)\0" "*.ico\0" 
						"J[\t@C (*.cur)\0" "*.cur\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileName(&ofn)){
		Add_OpenFILE(hList, hIml, ofn.nFileOffset, fn);
	}
}// Open_FileDlg

void Save_AniFile(HWND hDlg, HWND hList, char *filename)
{
	SendDlgItemMessage(hDlg, IDC_EDIT1, WM_GETTEXT,
						sizeof(ganiAcon.azTitle), (LPARAM) ganiAcon.azTitle);
	SendDlgItemMessage(hDlg, IDC_EDIT1, WM_GETTEXT,
						sizeof(ganiAcon.azCreator), (LPARAM) ganiAcon.azCreator);
	gnumFram2 = ListView_GetItemCount(hList);
	gpFram2 = new FRAME2 [gnumFram2];
	for(UINT i=0;i<gnumFram2;i++){
		PFRAME pfram = Get_Lparam(hList, i);
		if(pfram){
			strncpy(gpFram2[i].azCurFile, pfram->filename, sizeof(gpFram2[i].azCurFile));
			gpFram2[i].jifRate = atoi(pfram->jif);
		}
	}
	SaveFile(filename);
	if(gpFram2){
		delete [] gpFram2;
		gpFram2 = NULL;
	}
}// Save_AniFile

// Otĕۑi.anij
bool Save_FileDlg_Ani(HWND hDlg, HWND hList)
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hwndOwner    = hDlg;
	ofn.Flags        = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXTENSIONDIFFERENT;
	ofn.lpstrFile    = fn;
	ofn.lpstrDefExt  = "ani";
	ofn.nMaxFile     = sizeof(fn);
	ofn.lpstrFilter =	"Aj[V J[\ (*.ani)\0" "*.ani\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		Save_AniFile(hDlg, hList, fn);
		return true;
	}
	return false;
}// Save_FileDlg_Ani

// Xgr[̌ݑIĂACe폜
void Delete_ListviewItem(HWND hList, HIMAGELIST hIml, int idxSelect)
{
	KillTimer(g_hDlg, 1);
	if(idxSelect != -1){
		// C[WXg摜폜íAListView_DeleteItem ̑Oɍsj
		LVITEM		lvI1;
		ZeroMemory(&lvI1, sizeof(lvI1));
		lvI1.mask	= LVIF_IMAGE;
		lvI1.iItem	= idxSelect;
		ListView_GetItem(hList, &lvI1);
		ImageList_Remove(hIml, lvI1.iImage);
		// Xgr[̃ACe폜
		PFRAME pfram = Get_Lparam(hList, idxSelect);
		if(pfram){
			delete pfram;
		}
		ListView_DeleteItem(hList, idxSelect);
		int num = ListView_GetItemCount(hList);
		if(idxSelect >= num){
			idxSelect = num - 1;
		}
		if(idxSelect >= 0){
			int i;
			for(i=0; i<num; i++){
				// Xgr[ACẻ摜ԍ̍XV
				LVITEM		lvI2;
				ZeroMemory(&lvI2, sizeof(lvI2));
				lvI2.mask	= LVIF_IMAGE;
				lvI2.iItem	= i;
				ListView_GetItem(hList, &lvI2);
				if(lvI2.iImage >= lvI1.iImage)
					lvI2.iImage	--;
				ListView_SetItem(hList, &lvI2);
			}
			for(i=idxSelect; i<num; i++){
				// Xgr[ACe JIF ̍XV
				PFRAME pfram = Get_Lparam(hList, i);
				if(pfram){
					ListView_SetItemText(hList, i, 1, pfram->jif);
				}
			}
			// Xgr[ACẽtH[JXݒ
			ListView_SetItemState(hList, idxSelect, LVIS_FOCUSED | LVIS_SELECTED,
									LVIS_FOCUSED | LVIS_SELECTED);
		}
	}
	SetTimer(g_hDlg, 1, 100/6, NULL);
}// Delete_ListviewItem

// Xgr[̃ACe
// new_pos : ւ̈ʒui-1:O, 0:ʒu, 1:1j
void Change_ListviewItem(HWND hList, HIMAGELIST hIml, int idxSelect, int new_pos)
{
	int item_ct = ListView_GetItemCount(hList);
	if(idxSelect + new_pos < 0 || idxSelect + new_pos >= item_ct)
		return;
	
	LVITEM	lvI1,lvI2;
	char	name1[MAX_PATH] = "";
	char	name2[MAX_PATH] = "";
	
	ZeroMemory(&lvI1, sizeof(lvI1));
	lvI1.mask		= LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
	lvI1.iItem		= idxSelect;
	lvI1.pszText	= name1;
	lvI1.cchTextMax	= MAX_PATH;
	ListView_GetItem(hList, &lvI1);
	
	ZeroMemory(&lvI2, sizeof(lvI2));
	lvI2.mask		= LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
	lvI2.iItem		= idxSelect + new_pos;
	lvI2.pszText	= name2;
	lvI2.cchTextMax	= MAX_PATH;
	ListView_GetItem(hList, &lvI2);
	
	lvI1.iItem	= idxSelect + new_pos;
	lvI2.iItem	= idxSelect;
	
	ListView_SetItem(hList, &lvI1);
	ListView_SetItem(hList, &lvI2);
	
	// Xgr[ACe JIF ̍XV
	PFRAME pfram1 = Get_Lparam(hList, idxSelect);
	if(pfram1){
		ListView_SetItemText(hList, idxSelect, 1, pfram1->jif);
	}
	PFRAME pfram2 = Get_Lparam(hList, idxSelect + new_pos);
	if(pfram2){
		ListView_SetItemText(hList, idxSelect + new_pos, 1, pfram2->jif);
	}
	
	// Xgr[ACẽtH[JXݒ
	ListView_SetItemState(hList, lvI1.iItem, LVIS_FOCUSED | LVIS_SELECTED,
							LVIS_FOCUSED | LVIS_SELECTED);
}// Change_ListviewItem

// ANI t@C CUR t@C𔲂oۑ
void AniToIcons(char *ani_filename)
{
	if(Set_Dir(g_hDlg)){
		strncpy(ganiAcon2.azSavepath, g_path, sizeof(ganiAcon2.azSavepath));
		strncpy(ganiAcon2.azFilename, ani_filename, sizeof(ganiAcon2.azFilename));
		ReadAniFile();
	}
}// AniToIcons

int CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND			hList = NULL;
	static HWND			hEdit3 = NULL;
	static HWND			hPic1 = NULL;
	static HIMAGELIST	hIml = NULL;
	static int			idxSelect = -1;
	static int			anim_ct1 = 0;
	static RECT			rcPic;
	static char colText[COL_NUM][24] = {"t@C","JIF"};
	static int	colWdh[COL_NUM] = {120,40};
	static int	colFmt[COL_NUM] = {0,0};
	
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			ZeroMemory(&ganiAcon2, sizeof(ganiAcon2));
			// R}hCƂ
			if(__argc > 1){
				char *p = strrchr(__argv[1], '.');
				if(p && !stricmp(p, ".ani")){
					AniToIcons(__argv[1]);
					SendMessage(hDlg,WM_CLOSE,0,0);
					break;
				}
			}
			// RRg[
			InitCommonControls();
			// Xs̒l͈̔͂ݒ
			SendDlgItemMessage(hDlg, IDC_SPIN1, UDM_SETRANGE, 0 , MAKELONG(100, 1));
			// Xs̏lݒ
			SendDlgItemMessage(hDlg, IDC_SPIN1, UDM_SETPOS, 0 , MAKELONG(1, 0));
			// IDC_EDIT3 ̃nh̎擾
			hEdit3 = GetDlgItem(hDlg, IDC_EDIT3);
			// Xgr[nh̎擾
			hList = GetDlgItem(hDlg, IDC_LIST1);
			// sN`[nh̎擾
			hPic1 = GetDlgItem(hDlg, IDC_PIC1);
			if(!hList || !hPic1){
				SendMessage(hDlg,WM_CLOSE,0,0);
			}
			// sN`[̃TCY
			GetClientRect(hPic1, &rcPic);
			// J̒ǉ
			int 		i;
			LV_COLUMN	lvc;
			ZeroMemory(&lvc, sizeof(lvc));
			lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
			for(i=0;i<COL_NUM;i++){
				lvc.iSubItem = i;
				lvc.fmt = colFmt[i];
				lvc.cx = colWdh[i];
				lvc.pszText = colText[i];
				ListView_InsertColumn(hList, i, &lvc);
			}
			// C[WXg̍쐬
			UINT wdhIcon = GetSystemMetrics(SM_CXSMICON);
			UINT hgtIcon = GetSystemMetrics(SM_CYSMICON);
			hIml = ImageList_Create(wdhIcon, hgtIcon, ILC_COLORDDB, 0, 0);
			ListView_SetImageList(hList, hIml, LVSIL_SMALL);
			// R}hCƂ
			if(__argc > 1){
				FRAME	fram;
				strcpy(fram.jif, JIF_INIT);
				for(i=1;i<__argc;i++){
					strcpy(fram.filename, __argv[i]);
					GetFileTitle(fram.filename, fram.title, sizeof(fram.title));
					Add_One_Item(hList, hIml, fram);
				}
			}
			SetTimer(hDlg, 1, 100/6, NULL);
		}
		break;
		
	case WM_TIMER:
		{
			HDC hDC = GetDC(hPic1);
			PFRAME pfram = Get_Lparam(hList, anim_ct1);
			if(pfram){
				static int anim_ct2 = 0;
				if(anim_ct2 == 0){
					// ʂ̃NA
					RECT	rcPic;
					GetClientRect(hPic1, &rcPic);
					HBRUSH	hbr = GetSysColorBrush(COLOR_BTNFACE);
					FillRect(hDC, &rcPic, hbr);
					// ACR̕`
					HICON hIcon = (HICON) LoadImage(NULL, pfram->filename, IMAGE_ICON,
													0, 0, LR_LOADFROMFILE);
					ICONINFO inf;
					GetIconInfo(hIcon, &inf);
					BITMAP bmp;
					GetObject(inf.hbmColor, sizeof(BITMAP), &bmp);
					DeleteObject(inf.hbmColor);
					DeleteObject(inf.hbmMask);
					int x = (rcPic.right - bmp.bmWidth) / 2;
					int y = (rcPic.bottom - bmp.bmHeight) / 2;
					DrawIconEx(hDC, x, y, hIcon, 0, 0, 0, NULL, DI_NORMAL);
					DestroyIcon(hIcon);
				}
				anim_ct2 ++;
				if(anim_ct2 >= atoi(pfram->jif)){
					anim_ct2 = 0;
				}
				if(anim_ct2 == 0){
					anim_ct1 ++;
					int num = ListView_GetItemCount(hList);
					if(anim_ct1 >= num){
						anim_ct1 = 0;
					}
				}
			}
			ReleaseDC(hPic1, hDC);
		}
		break;
		
	case WM_DROPFILES:
		{
			int		i,r;
			HDROP	hDrop;
			FRAME	fram;
			
			hDrop = (HDROP) wParam;
			r = DragQueryFile(hDrop, (UINT)-1, NULL, 0);
			strcpy(fram.jif, JIF_INIT);
			for(i=0;i<r;i++){
				DragQueryFile(hDrop, i, fram.filename, sizeof(fram.filename));
				char fname[_MAX_FNAME];	// t@C
				char ext[_MAX_EXT];		// gq
				_splitpath(fram.filename, 0, 0, fname, ext);
				if(!stricmp(ext, ".cur") || !stricmp(ext, ".ico")){
					GetFileTitle(fram.filename, fram.title, sizeof(fram.title));
					Add_One_Item(hList, hIml, fram);
				}
				if(!stricmp(ext, ".ani")){
					AniToIcons(fram.filename);
					SendMessage(hDlg,WM_CLOSE,0,0);
					break;
				}
			}
			DragFinish(hDrop);
		}
		break;
		
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON1:	// ǉ
			if(HIWORD(wParam) == BN_CLICKED)
				Open_FileDlg(hDlg, hList, hIml);
			break;
			
		case IDC_BUTTON2:	// 폜
			if(HIWORD(wParam) == BN_CLICKED){
				Delete_ListviewItem(hList, hIml, idxSelect);
				anim_ct1 = 0;
				if(hPic1 && 0 == ListView_GetItemCount(hList)){
					// ʂ̃NA
					HDC hDC = GetDC(hPic1);
					GetClientRect(hPic1, &rcPic);
					HBRUSH	hbr = GetSysColorBrush(COLOR_BTNFACE);
					FillRect(hDC, &rcPic, hbr);
				}
			}
			break;
			
		case IDC_BUTTON3:	// 
			if(HIWORD(wParam) == BN_CLICKED)
				Change_ListviewItem(hList, hIml, idxSelect, -1);
			break;
			
		case IDC_BUTTON4:	// 
			if(HIWORD(wParam) == BN_CLICKED)
				Change_ListviewItem(hList, hIml, idxSelect, 1);
			break;
			
		case IDC_EDIT3:
			if(HIWORD(wParam) == EN_CHANGE && GetFocus() == hEdit3){
				PFRAME pfram = Get_Lparam(hList, idxSelect);
				if(pfram){
					char strJif[JIF_LEN];
					SendMessage(hEdit3, WM_GETTEXT, sizeof(strJif), (LPARAM) strJif);
					strncpy(pfram->jif, strJif, sizeof(strJif));
					ListView_SetItemText(hList, idxSelect, 1, strJif);
				}
			}
			break;
			
		case IDOK:
			{
				KillTimer(hDlg, 1);
				if(Save_FileDlg_Ani(hDlg, hList)){
					SendMessage(hDlg,WM_CLOSE,0,0);
				}
				SetTimer(hDlg, 1, 100/6, NULL);
			}
			break;
			
		case IDCANCEL:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
			
		default:
			return FALSE;
		}
		break;
		
	case WM_NOTIFY:
		{
			NMHDR *phdr = (NMHDR*) lParam;
			switch(phdr->code)
			{
			case LVN_COLUMNCLICK:	// JNbNꂽ
				if(phdr->hwndFrom == hList){
					LPNMLISTVIEW pnmlv = (LPNMLISTVIEW) lParam;
					// ёւ
					ListView_SortItems(hList, ProcListViewCmp, (LPARAM)(pnmlv->iSubItem));
					// IACeԍ̐ݒ
					int num = ListView_GetItemCount(hList);
					for(int i=0;i<num;i++){
						UINT flag = ListView_GetItemState(hList, i, LVIS_SELECTED);
						if(flag & LVIS_SELECTED){
							idxSelect = i;
							break;
						}
					}
				}
				break;
				
			case LVN_ITEMCHANGED:	// ACȇIς
				if(phdr->hwndFrom == hList){
					LPNMLISTVIEW pnmlv = (LPNMLISTVIEW) lParam;
					idxSelect = pnmlv->iItem;
					PFRAME pfram = Get_Lparam(hList, idxSelect);
					if(pfram){
						SendMessage(hEdit3, WM_SETTEXT, 0, (LPARAM) pfram->jif);
					}
				}
				break;
				
			default:
				return FALSE;
			}
		}
		break;
		
	case WM_CLOSE:
		{
			KillTimer(hDlg, 1);
			int i,num = ListView_GetItemCount(hList);
			for(i=0;i<num;i++){
				PFRAME pfram = Get_Lparam(hList, i);
				if(pfram){
					delete pfram;
				}
			}
			if(hIml){
				ImageList_Destroy(hIml);
			}
			DestroyWindow(hDlg);
			PostQuitMessage(0);
		}
		break;
		
	default:
		return FALSE;
	}
	return TRUE;
}// DlgProc

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	g_hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
	ShowWindow(g_hDlg, nCmdShow);
	
	MSG 	msg;
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(g_hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain
